<?php
/**
 * Created by JetBrains PhpStorm.
 * User: jorgefonseca
 * Date: 22/11/13
 * Time: 10:20
 * To change this template use File | Settings | File Templates.
 */

namespace Folha\Logic;


class Calculo {

    private function _calculaDiversos(
        FpaitecalcfolhaEntity $itens_calculo, $incidencia, $nr_evento, $percentual, TkDateTime $mes_competencia,
        $base = 0.0
    ) {
        //BORBA 27/06/2013
        if (($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_FOLHA)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO)
            || ($this->_nr_tipo_calculo === FpatipocalculoEntity::CALC_RESCISAO_COMPLEMENTAR)
        ){
            //BORBA 29/05/2013
            if ( $this->_itens_calculo_principal!==$itens_calculo ){
                // Normalmente quando rescisao chama ferias, 13sal, aviso previo o periodo é sempre integral
                $this->_baseCorrespPeriodoIntegral = true;
            } else {
                // No mensal e na rescisao propriamente pode ser proporcional a não ser que a incidencia retorne 0 (zero)
                // e que o metodo use o salário como base deixando a cargo do calcula base retornar true ou não.
                $this->_baseCorrespPeriodoIntegral = false;
            }

        } else {
            $this->_baseCorrespPeriodoIntegral = true;
        }

        $evento_aux = $this->_assoc_eventos->retornaEventoAssociado($nr_evento, $this->_eventom, $this->_nrorg);

        if ($evento_aux !== null) {
            // @todo Testar se o evento possui associacao. Imprimir menssagem de erro.
            $itens = $itens_calculo->retornaItens($evento_aux);

            if ($base === 0.0) {
                $base = $this->_calculaBase($itens_calculo, $incidencia, $mes_competencia);
            } else{
                $this->_baseCorrespPeriodoIntegral = true;
            }
//if ($nr_evento == 60){
//    tk_warning('PERICULOSIDADE '.$base);
//}
            $tipo_referencia = $evento_aux->historico->getIdunidrefereven();

            $qtd_dias = 0;
            foreach ($itens as $indice) {
                $referencia = $itens_calculo->retornaReferencia($indice);

                /* echo "<CALCULO>TpRef: $tipo_referencia  NrEve: ".$evento_aux->getNreventom()."<br/>";*/
                switch ($tipo_referencia) {
                    case FpaeventohEntity::IDUNIDREFEREVEN_PERCENTUAL:
                        //BORBA 12/11/2013 Para medias de valor em que a preparação zera a referencia.
                        if($referencia!=0){
                            $valor_item = ($base * $referencia)/100;

                        }else{
                            $valor_item=$itens_calculo->retornaValor($indice);
                        }


//                    if ($nr_evento == 60){
//                        tk_warning('PERICULOSIDADE V '.$valor_item.' '.$referencia);
//                    }

                        break;
                    case FpaeventohEntity::IDUNIDREFEREVEN_DIA :
                    case FpaeventohEntity::IDUNIDREFEREVEN_HORA :
                    case FpaEventohEntity::IDUNIDREFEREVEN_HORA_MINUTO:
                        //if ($this->_baseCorrespPeriodoIntegral === true) {

                        if ($this->_baseCorrespPeriodoIntegral === false) {
                            $valor_hora = $base / $this->_calculaHoraEfetivas();
                        } else {
                            $valor_hora = $base / ($this->_jornada_diaria * 30);
                        }

                        /* aplica o percentual no valor hora*/
                        $valor_hora = ($valor_hora * $percentual)/100;
                        $ref_hora = FpaeventohEntity::compatibilizaReferenciaHoras(
                            $referencia, $tipo_referencia, $this->_jornada_diaria
                        );
                        $valor_item = $valor_hora * $ref_hora;

                        if ($referencia === $ref_hora) {
                            // Para tipo de referencia HORA e HORA_MINUTO com valor inteiro
                            $qtd_dias += ($referencia / $this->_jornada_diaria);
                        } else {

                            if ($tipo_referencia === FpaeventohEntity::IDUNIDREFEREVEN_DIA) {
                                $qtd_dias += $referencia;
                            } else {
                                // Para tipo de referencia HORA_MINUTO com valor quebrado
                                $qtd_dias += ($ref_hora / $this->_jornada_diaria);
                            }

                        }

                        break;
                    case FpaeventohEntity::IDUNIDREFEREVEN_12_AVOS:
                        $valor_item = ($base * $referencia)/12;
                        $valor_item = ($valor_item * $percentual)/100;
                        break;
                    default:
                        /* @todo Converter para tk_show_message*/
                        $msg = 'Tipo de referência '.$tipo_referencia.' não tratada - CalculaDiversos - CALCULO.PHP';
                        $msg .= ' Evento: '.$evento_aux->historico->getNmeventoh();
                        $msg .= ' Ref: '.$referencia.' Valor: '.$valor_item;
                        $msg .= ' Vínculo: '.$this->_vinculo->getNrvinculom().' Valor: ';
                        tk_warning($msg);

                        break;
                }
//                if ($nr_evento == 60){
//                    tk_warning('PERICULOSIDADE V1 '.$valor_item.' '.$referencia);
//                }
                $dtocorrencia = new TkDateTime($itens_calculo->retornaDtocorrencia($indice));
                $itens_calculo->geraEvento($evento_aux, $dtocorrencia, (float)$valor_item, $referencia, 1);
                unset($dtocorrencia);
            }

            /* Utilizado na rescisao para projetar a data em funcao de indenizacoes lancadas/geradas
             * pelo usuario no movimento
             */
            return $qtd_dias;
        } else {
            tk_warning('Evento não associado.');
        }
    }

    private function _calculaBase(FpaitecalcfolhaEntity$itens_calculo, $incidencia, TkDateTime $mes_competencia){
        /* A incidencia pode vir nula no caso de CalculaSalario*/
        if ($incidencia !== null) {
            $base = $itens_calculo->calculaIncidencias($incidencia, $mes_competencia, $this->_eventom);
            if ($base === 0.0) {
                $this->_baseCorrespPeriodoIntegral = true;
                $base = $this->_salario;
            }
        } else {
            $this->_baseCorrespPeriodoIntegral = true;
            $base = $this->_salario;
        }

        return $base;
    }

}